/*********************************************************************          
 *                                                                   *          
 *         Licensed Materials - Program Property of IBM.             *          
 *         This product contains "Restricted Materials of IBM"       *          
 *         5647-A01 (C) Copyright IBM Corp. 1992, 1997.              *          
 *         All rights reserved.                                      *          
 *         US Government Users Restricted Rights -                   *          
 *         Use, duplication or disclosure restricted                 *          
 *         by GSA ADP Schedule Contract with IBM Corp.               *          
 *         Refer to Copyright Instructions                           *          
 *         Form Number G120-2083.                                    *          
 *                                                                   *          
 *********************************************************************/         
                                                                                
/*------------------------ cbsamplh.h --------------------------------*         
 |  This is the header file for the sample program, cbsample.         |         
 |  It is  used by cbsamplm.c and cbsamplc.c on the host and          |         
 |  cbsamplx.c and cbsamplc.c on the workstation.                     |         
 *--------------------------------------------------------------------*/        
                                                                                
#if defined(MVS)                                                                
#define PREFIXmessagesWITHname PFXmsgNA                                         
#define TIMESTAMPmessages      TSmessag                                         
#endif                                                                          
                                                                                
#if defined(MAINprogram)                                                        
int PREFIXmessagesWITHname = 0;                                                 
int TIMESTAMPmessages = 1;                                                      
#else                                                                           
#if !defined(MVS)                                                               
extern int PREFIXmessagesWITHname;                                              
extern int TIMESTAMPmessages;                                                   
#endif                                                                          
#endif                                                                          
                                                                                
#define msg(nn,monstring,thestring) \                                           
  { char       buf200[200]; \                                                   
    char      *atimenow; \                                                      
    time_t     ltimenow; \                                                      
    struct tm *timenow; \                                                       
    if (monitor_the_monitor) \                                                  
       if (sizeof(monstring) > 0) \                                             
          printf(monstring); \                                                  
    if (debug >= abs(nn)) \                                                     
      { if (nn < 0) \                                                           
          sprintf(buf200,"%s\n",divider); \                                     
          else strcpy(buf200,""); \                                             
        if (PREFIXmessagesWITHname) \                                           
          { strcat(buf200,msgp); strcat(buf200," "); } \                        
        if (TIMESTAMPmessages) \                                                
          { time(&ltimenow); timenow = localtime(&ltimenow); \                  
            atimenow = asctime(timenow); \                                      
            atimenow[24] = ':'; atimenow[25] = '\0'; \                          
            strcat(buf200,atimenow); strcat(buf200, " "); \                     
          } \                                                                   
        strcat(buf200,thestring); strcat(buf200,"\n"); \                        
        printf(buf200); \                                                       
      } \                                                                       
  }                                                                             
                                                                                
#define msg1(nn,thestring, a) \                                                 
  { char       buf200[200]; \                                                   
    char      *atimenow; \                                                      
    time_t     ltimenow; \                                                      
    struct tm *timenow; \                                                       
    if (debug >= abs(nn)) \                                                     
      { if (nn < 0) \                                                           
          sprintf(buf200,"%s\n",divider); \                                     
          else strcpy(buf200,""); \                                             
        if (PREFIXmessagesWITHname) \                                           
          { strcat(buf200,msgp); strcat(buf200," "); } \                        
        if (TIMESTAMPmessages) \                                                
          { time(&ltimenow); timenow = localtime(&ltimenow); \                  
            atimenow = asctime(timenow); \                                      
            atimenow[24] = ':'; atimenow[25] = '\0'; \                          
            strcat(buf200,atimenow); strcat(buf200, " "); \                     
          } \                                                                   
        strcat(buf200,thestring); strcat(buf200,"\n"); \                        
        printf(buf200, a); \                                                    
      } \                                                                       
  }                                                                             
                                                                                
#define msg2(nn,thestring, a,b) \                                               
  { char       buf200[200]; \                                                   
    char      *atimenow; \                                                      
    time_t     ltimenow; \                                                      
    struct tm *timenow; \                                                       
    if (debug >= abs(nn)) \                                                     
      { if (nn < 0) \                                                           
          sprintf(buf200,"%s\n",divider); \                                     
          else strcpy(buf200,""); \                                             
        if (PREFIXmessagesWITHname) \                                           
          { strcat(buf200,msgp); strcat(buf200," "); } \                        
        if (TIMESTAMPmessages) \                                                
          { time(&ltimenow); timenow = localtime(&ltimenow); \                  
            atimenow = asctime(timenow); \                                      
            atimenow[24] = ':'; atimenow[25] = '\0'; \                          
            strcat(buf200,atimenow); strcat(buf200, " "); \                     
          } \                                                                   
        strcat(buf200,thestring); strcat(buf200,"\n"); \                        
        printf(buf200, a,b); \                                                  
      } \                                                                       
  }                                                                             
                                                                                
#define msg3(nn,thestring,a,b,c) \                                              
  { char       buf200[200]; \                                                   
    char      *atimenow; \                                                      
    time_t     ltimenow; \                                                      
    struct tm *timenow; \                                                       
    if (debug >= abs(nn)) \                                                     
      { if (nn < 0) \                                                           
           sprintf(buf200,"%s\n",divider); \                                    
           else strcpy(buf200,""); \                                            
        if (PREFIXmessagesWITHname) \                                           
          { strcat(buf200,msgp); strcat(buf200," "); } \                        
        if (TIMESTAMPmessages) \                                                
          { time(&ltimenow); timenow = localtime(&ltimenow); \                  
            atimenow = asctime(timenow); \                                      
            atimenow[24] = ':'; atimenow[25] = '\0'; \                          
            strcat(buf200,atimenow); strcat(buf200, " "); \                     
          } \                                                                   
        strcat(buf200,thestring); strcat(buf200,"\n"); \                        
        printf(buf200, a,b,c); \                                                
      } \                                                                       
  }                                                                             
                                                                                
#define msg4(nn,thestring, a,b,c,d) \                                           
  { char       buf200[200]; \                                                   
    char      *atimenow; \                                                      
    time_t     ltimenow; \                                                      
    struct tm *timenow; \                                                       
    if (debug >= abs(nn)) \                                                     
      { if (nn < 0) \                                                           
          sprintf(buf200,"%s\n",divider); \                                     
          else strcpy(buf200,""); \                                             
        if (PREFIXmessagesWITHname) \                                           
          { strcat(buf200,msgp); strcat(buf200," "); } \                        
        if (TIMESTAMPmessages) \                                                
          { time(&ltimenow); timenow = localtime(&ltimenow); \                  
            atimenow = asctime(timenow); \                                      
            atimenow[24] = ':'; atimenow[25] = '\0'; \                          
            strcat(buf200,atimenow); strcat(buf200, " "); \                     
          } \                                                                   
        strcat(buf200,thestring); strcat(buf200,"\n"); \                        
        printf(buf200, a,b,c,d); \                                              
      } \                                                                       
    }                                                                           
                                                                                
#define msg5(nn,thestring, a,b,c,d,e) \                                         
  { char       buf200[200]; \                                                   
    char      *atimenow; \                                                      
    time_t     ltimenow; \                                                      
    struct tm *timenow; \                                                       
    if (debug >= abs(nn)) \                                                     
      { if (nn < 0) \                                                           
          sprintf(buf200,"%s\n",divider); \                                     
          else strcpy(buf200,""); \                                             
        if (PREFIXmessagesWITHname) \                                           
          { strcat(buf200,msgp); strcat(buf200," "); } \                        
        if (TIMESTAMPmessages) \                                                
          { time(&ltimenow); timenow = localtime(&ltimenow); \                  
            atimenow = asctime(timenow); \                                      
            atimenow[24] = ':'; atimenow[25] = '\0'; \                          
            strcat(buf200,atimenow); strcat(buf200, " "); \                     
          } \                                                                   
        strcat(buf200,thestring); strcat(buf200,"\n"); \                        
        printf(buf200, a,b,c,d,e); \                                            
      } \                                                                       
  }                                                                             
                                                                                
#if defined(MVS)                                                                
#define ReadMibRecord     ReadMiRe                                              
#define ReadNetstatRecord ReadNeRe                                              
#define TimeoutForSelect  TOFSelec                                              
#endif                                                                          
                                                                                
typedef enum { min_sec, integer } parse_types;                                  
typedef enum { SECONDS, MILLISECONDS } resolution_types;                        
                                                                                
#if !defined(Boolean)                                                           
#define Boolean int                                                             
#endif                                                                          
                                                                                
#if !defined(FALSE)                                                             
#define FALSE 0                                                                 
#define TRUE  1                                                                 
#endif                                                                          
                                                                                
#if defined(SUN4)                                                               
#define RAND_MAX 0x00007FFF;                                                    
#endif                                                                          
                                                                                
#define MAXbufsize            8192                                              
                                                                                
/* sizes for datagrams sent to server */                                        
#define MINrequestLENGTH      3*sizeof(int) + sizeof(double)                    
#define SIZEOFdgramHEADER     10*sizeof(int) + sizeof(double)                   
#define DATAlen               MAXbufsize - SIZEOFdgramHEADER                    
#define MIBtopSIZE            13*4 + sizeof(double)                             
#define RESETserverSIZE       MIBtopSIZE + sizeof(MibResponseType) + 4*4        
#define REQUESTstatisticsSIZE 3*sizeof(int) + sizeof(double)                    
                                                                                
#define INITsorcvbuf 40 * 1024                                                  
#define INITsosndbuf 40 * 1024                                                  
                                                                                
/* sizes for datagrams returned to client */                                    
#define STATISTICSfieldsVALIDsize MIBtopSIZE + sizeof(MibResponseType)          
#define MINackLENGTH              8*4 + sizeof(double)                          
#define MAXnetstatRESPONSElength  8192                                          
                                                                                
#define FROMmvs               0x04000000                                        
#define FROMunixHOST          0x02000000                                        
#define USINGxDISPLAY         0x01000000                                        
#define ACKdgram              0x00800000                                        
#define STATISTICSfieldsVALID 0x00400000                                        
#define QUEUEINGisAVAILABLE   0x00200000                                        
#define QUEUEINGisON          0x00100000                                        
#define RESETserver           0x00008000                                        
#define CHANGEackLEN          0x00004000                                        
#define CHANGEqueueing        0x00002000                                        
#define TOGGLEqueueing        0x00001000                                        
#define CHANGEpacing          0x00000800                                        
#define REQUESTstatistics     0x00000080                                        
#define REQUESTnetstat        0x00000004                                        
#define REQUESTack            0x00000040                                        
#define MUSTack               0x00000020                                        
#define LASTdgram             0x00000010                                        
#define SHUTDOWNonLASTdgram   0x00000008                                        
                                                                                
#define ProfileName                   ProfileN                                  
#define usexbench                     usexbenc                                  
                                                                                
typedef struct {                                                                
  unsigned int  arpInRequests  ;                                                
  unsigned int  arpOutRequests ;                                                
  unsigned int  arpInReplies   ;                                                
  unsigned int  arpOutReplies  ;                                                
  unsigned int  ioReads        ;                                                
  unsigned int  ioWrites       ;                                                
  unsigned int  ioHCInOctets   ;                                                
  unsigned int  ioInOctets     ;                                                
  unsigned int  ioHCOutOctets  ;                                                
  unsigned int  ioOutOctets    ;                                                
  unsigned long icmpInMsgs     ;                                                
  unsigned long icmpOutMsgs    ;                                                
  unsigned int  ipForwDatagrams;                                                
  unsigned int  ipFragCreates  ;                                                
  unsigned int  ipFragFails    ;                                                
  unsigned int  ipFragOKs      ;                                                
  unsigned int  ipInAddrErrors ;                                                
  unsigned int  ipInHdrErrors  ;                                                
  unsigned int  ipInReceives   ;                                                
  unsigned int  ipOutRequests  ;                                                
  unsigned int  ipReasmFails   ;                                                
  unsigned int  ipReasmOKs     ;                                                
  unsigned int  ipReasmReqds   ;                                                
  unsigned int  tcpInSegs      ;                                                
  unsigned int  tcpOutSegs     ;                                                
  unsigned int  tcpRetransSegs ;                                                
  unsigned int  tcpConnections ;                                                
  unsigned long udpInDatagrams ;                                                
  unsigned long udpOutDatagrams;                                                
  unsigned int  TotCPUtime1    ; /* Total CPU time (in seconds)      */         
  unsigned int  TotCPUtime2    ; /* Total CPU time (fractional part) */         
  unsigned int  csaTotAllocated;                                                
  unsigned int  csaTotInUse    ;                                                
} MibResponseType;                                                              
                                                                                
                                                                                
typedef struct dgram_format_                                                    
                      /* FROM: (X=set, x=set if reliable protocol,    */        
                      /* client----+      E=echoed)                   */        
                      /* server---+|                                  */        
                      /*          || WHEN FIELD IS VALID:             */        
                      /*          vv -------------------------------- */        
 { int dgram_length;  /*           X =-1 when last, otw.=dgram length.*/        
   int dgram_num;     /*          EX                                  */        
   double start_time; /*          Ex <- make sure this is on DW bdy !!*/        
   int flags;         /*          XX  always valid                    */        
   int AccumBlockingReceives;/*   X   always valid from server        */        
   int AccumBytesReceived;/*      X   always valid from server        */        
   int AccumBytesSent;/*          X   always valid from server        */        
   int AccumDgramsReceived;/*     X   always valid from server        */        
   int AccumDgramsSent;/*         X   always valid from server        */        
   int AccumNonBlockingReceives;/*X   always valid from server        */        
   int AccumDaemonCpuTaskTime;/*  X  STATISTICSfieldsVALID in response*/        
   int AccumIUCVReceiveMessages;/*X  STATISTICSfieldsVALID to REQUEST-*/        
   int AccumIUCVSendMessages; /*  X  STATISTICSfieldsVALID STATISTICS */        
   int Reserved;      /*             Not used - available             */        
   MibResponseType MibResponse;/* X  STATISTICSfieldsVALID   ...      */        
   int NewAckLen;     /*           X CHANGEackLEN                     */        
   int NewPacing;     /*           X CHANGEpacing                     */        
   int NewRecvQSize;  /*           X CHANGEqueueing | TOGGLEqueueing  */        
   int NewSendQSize;  /*           X CHANGEqueueing | TOGGLEqueueing  */        
   int cpu_time;      /*           X LASTdgram             (in usec.) */        
   int elapsed_time;  /*           X     |                 (in usec.) */        
   int ave_turnaround_time;/*      X     |                 (in usec.) */        
   int nbufsent;      /*           X     |                            */        
   int nbytsent;      /*           X     |                            */        
   int nbufrcvd;      /*           X     |                            */        
   int nbytrcvd;      /*           X     |                            */        
   int nduprcvd;      /*           X     |                            */        
   int ntimeout;      /*           X     |                            */        
   int nbufrsnt;      /*           X     |                            */        
   int nbytrsnt;      /*           X     |                            */        
   int nIUCVsent;     /*           X     |                            */        
   int nIUCVrcvd;     /* __________X_____v___________________________ */        
   char data_part[DATAlen];                                                     
 } dgram_format, *dgram_format_ptr;                                             
                                                                                
#if defined(CBSAMPLX_MODULE)                                                    
#define NUMnetstatBUTTONS             18                                        
char netstat_strings[NUMnetstatBUTTONS][36] =                                   
                          { "none",                                             
                            "netstat all                       ",               
                            "netstat allconn                   ",               
                            "netstat arp       ",                               
                            "netstat clients                   ",               
                            "netstat conn                      ",               
                            "netstat devlinks                  ",               
                            "netstat gate                      ",               
                            "netstat home                      ",               
                            "netstat interval  ",                               
                            "netstat poolsize                  ",               
                            "netstat sockets                   ",               
                            "netstat statistics                ",               
                            "netstat tcp       ",                               
                            "netstat telnet                    ",               
                            "netstat test                      ",               
                            "netstat up                        ",               
                            "ping                              " };             
                                                                                
#define NUMhelpBUTTONS             6                                            
char help_titles[NUMhelpBUTTONS][23] = {                                        
                      "Introduction      ",  /* the first frame       */        
                                             /* with the introduction */        
                      "Starting cbsample ",                                     
                      "Startup options   ",                                     
                      "About the buttons ",                                     
                      "About the plots   ",                                     
                      "About the signals " };                                   
                                                                                
char help_string0[] = {                                                         
"                                                                           \n\ 
 Introduction:                                    Version 1.05a             \n\ 
 ------------                                                               \n\ 
                                                                            \n\ 
 cbsample runs on CS/390 V2R5 or later.  It can be used to                  \n\ 
 graphically monitor internal host TCPIP variables, which includes many     \n\ 
 of the MIB variables that are also available to SNMP.  It is intended      \n\ 
 to monitor the key indicators of TCPIP internal loads, and some            \n\ 
 exception events; while placing a minimum load on the host.                \n\ 
                                                                            \n\ 
 The program that runs on the MVS host will be referred to here as          \n\ 
 the \"server\" and the program that runs on the RISC 6000 or SUN           \n\ 
 workstation will be referred to as the \"client\".                         \n\ 
                                                                            \n\ 
                                                                            \n\ 
 Change History:                                                            \n\ 
 --------------                                                             \n\ 
  1.0   25May92: Initial release.                                           \n\ 
  1.01  28Jan93: Support for AIX 3.2.                                       \n\ 
  1.02  09Feb93: Support for SUN4.                                          \n\ 
  1.03b 02May93: Misc improvements:                                         \n\ 
                 - Improve plotting.. avoid blanking the plot when the      \n\ 
                   Y-axis is updated, allow plot to scale downward when     \n\ 
                   it's Y-axis range reduces, fix bug causing plot to swing \n\ 
                   below the X-axis at end of plot.  Improve timing of      \n\ 
                   sample interval.                                         \n\ 
                 - Add TOD, Trace, Threshold, Help, Snapshot, and Print     \n\ 
                   functions.                                               \n\ 
                 - Add TCPIP Working Set Size and TCPIP Turnaround Time     \n\ 
                   to plots.                                                \n\ 
                 - If we lose connection to host, print out messages and    \n\ 
                   eventually exit.                                         \n\ 
  1.03c 30Jun93: Accept MVS operator STOP command.  Include directions for  \n\ 
                 starting server on MVS in a batch job or started task.     \n\ 
  1.04a 08Aug96: Changes to allow C program (CBSAMPLC) to compile and       \n\ 
                    run on MVS with MVS TCP/IP V3R2. No Client changes      \n\ 
                    are required.  V1.03c will run fine on the client       \n\ 
                    machines.                                               \n\ 
  1.05a 01Jul97: Changes to allow server to compile and run on OS/390       \n\ 
                 V2R5 or later. New IOCTL interface (SIOCGMONDATA) used     \n\ 
                 to acquire a modified set of statistics. Xdefaults         \n\ 
                 changed as appropriate.  AIX support upgraded to V4,       \n\ 
                 SUN support upgraded to V5.6, VM support dropped.          \n\ 
                                                                          \n"}; 
                                                                                
/**********************************************************************/        
                                                                                
char help_string1a[] = {                                                        
"                                                                           \n\ 
 Starting cbsample:                                                         \n\ 
 -----------------                                                          \n\ 
                                                                            \n\ 
 The server needs to be installed on the MVS host before you can start      \n\ 
 to monitor that TCPIP.  To install the server, refer to                    \n\ 
 \"CBSAMPLE.README\"  included in the tar file.                             \n\ 
                                                                            \n\ 
 To start the server on an MVS host, you have several options:              \n\ 
                                                                            \n\ 
   1. CBSAMPLE can be automatically started when TCP/IP starts by           \n\ 
      including it in the TCPIP Profile dataset using the AUTOLOG and       \n\ 
      PORT statements.  Check with your TCP/IP System Administrator to      \n\ 
      see if it is available on your system as a standard server.  This     \n\ 
      is the best way to run the CBSAMPLE server.                           \n\ 
                                                                            \n\ 
   2. CBSAMPLE can be run by a batch job.  Following is sample JCL to do    \n\ 
      this:                                                                 \n\ 
                                                                            \n\ 
//CBSAMPLE JOB ,RUN,NOTIFY=userid,MSGLEVEL=(1,1),TIME=1440                  \n\ 
//CBSAMPLE PROC PROCPGM='CBSAMPLE',                                         \n\ 
//*-------------------------------------------------------------------*     \n\ 
//*                Library Substitution Variables                     *     \n\ 
//*-------------------------------------------------------------------*     \n\ 
//  OERTLPFX='OpenEdition Run Time Library',                                \n\ 
//  USERLOAD='your_load_library',                                           \n\ 
//*                                                                         \n\ 
//RUN      EXEC PGM=&PROCPGM,                                               \n\ 
//      PARM='\\-montcpip -po5001',REGION=4096K                             \n\ 
//STEPLIB  DD  DSNAME=&USERLOAD,DISP=SHR                                    \n\ 
//         DD  DSNAME=&OERTLPFX..SCEERUN,DISP=SHR                           \n\ 
//SYSPRINT DD  SYSOUT=*                                                     \n\ 
//SYSIN    DD  DUMMY                                                        \n\ 
//    PEND                                                                  \n\ 
//    EXEC PROC=CBSAMPLE                                                    \n\ 
                                                                            \n\ 
      If someone is already using that port, select another.  Make sure     \n\ 
      client uses the same port number.                                     \n\ 
                                                                            \n\ 
   3. CBSAMPLE can be run under a TSO session.  To do this, issue the       \n\ 
      following from a TSO session:                                         \n\ 
                                                                            \n\ 
           call 'your_loadlib(cbsample)' '-montcpip -po5001'                \n\ 
                                                                            \n\ 
      If someone is already using that port, select another.  Make sure     \n\ 
      client uses the same port number.                                     \n\ 
                                                                          \n"}; 
char help_string1b[] = {                                                        
"The server is now waiting for a request to be received from the client     \n\ 
 running on the workstation.  The server listens on the default port (5001).\n\ 
 When the client is started, the client starts sending messages to the      \n\ 
 server at this port requesting the current information about the host      \n\ 
 TCPIP.  When one of these messages is received by the server, the server   \n\ 
 gathers the information from TCPIP via an IOCTL SIOCGMONDATA               \n\ 
 command and returns it to the client.  The client then displays the        \n\ 
 information on the graphical monitor.                                      \n\ 
                                                                            \n\ 
 To start the client (if you haven't done so already):                      \n\ 
                                                                            \n\ 
 On the RISC 6000 (under X-Windows) on the SUN (under Open Look), issue     \n\ 
 the following:                                                             \n\ 
                                                                            \n\ 
             cbsample -xmonload -h<your_MVS_host> -po5001                   \n\ 
                             or                                             \n\ 
             cbsample -xmonexcp -h<your_MVS_host> -po5001                   \n\ 
                                                                            \n\ 
 depending on the type of display you want.  Refer to the                   \n\ 
 \"Startup options\" help frame for additional information.                 \n\ 
                                                                          \n"}; 
                                                                                
char help_string1c[] = {                                                        
" <your_MVS_host> can be either the symbolic name or dotted decimal         \n\ 
 address of your MVS host to be monitored.                                  \n\ 
                                                                            \n\ 
           For example:  cbsample -xmonexcp -hyktmvs                        \n\ 
                    or:  cbsample -xmonexcp -h129.34.128.247                \n\ 
                                                                            \n\ 
 After you have issued the above, a window should pop up showing            \n\ 
 several plotting areas and some buttons.                                   \n\ 
                                                                            \n\ 
 Make sure that the server is running.  Then start the client monitor by    \n\ 
 pressing the 'Start' button.                                               \n\ 
                                                                            \n\ 
 After a few seconds, the display should start showing timeseries           \n\ 
 plots of the variables.  The monitor is updated approximately every second,\n\ 
 and approximately 200 seconds of previous activity are shown.  Below       \n\ 
 each plot are the names of the variables in colors corresponding to        \n\ 
 the line color in the plot.  The number directly to the right of a         \n\ 
 variable name is its value from the previous interval.                     \n\ 
 The second number is the average for the variable.                         \n\ 
                                                                            \n\ 
 To refresh the entire window, press the 'Clear' button.  To refresh        \n\ 
 an individual plot, press the left mouse button while the cursor is        \n\ 
 over that plot.  This should clear the plot area, and reset the            \n\ 
 vertical axis.                                                             \n\ 
                                                                            \n\ 
 To stop the client, press the 'Quit' button.                               \n\ 
                                                                            \n\ 
 Stopping the server on the MVS host depends on how it was started:         \n\ 
                                                                            \n\ 
   1. If as a started task, then issuing an MVS operator STOP command:      \n\ 
         p cbsample                                                         \n\ 
      from the operator's console will stop the program.  (Note that if you \n\ 
      have the server listed on the AUTOLOG list in the TCPIP profile       \n\ 
      dataset, then TCPIP will start the server again.                      \n\ 
      Stopping TCPIP using an MVS operator STOP command:                    \n\ 
         p tcpip                                                            \n\ 
      will also stop the cbsample server.                                   \n\ 
                                                                            \n\ 
   2. If as a batch job, then cancelling the job will stop it.              \n\ 
                                                                            \n\ 
   3. If you are running it under a TSO session, then press the key which   \n\ 
      causes your keyboard to \"unlock\", then press the Attention Key.     \n\ 
      You would do this in the TSO terminal session in which you started the\n\ 
      server program.  Anything which cancels the userid (such as issuing   \n\ 
      an operator CANCEL command to the userid, will stop the server.       \n\ 
                                                                            \n\ 
 Refer to the \"Startup options\" help frame for additional information.    \n\ 
                                                                          \n"}; 
                                                                                
/**********************************************************************/        
                                                                                
char help_string2a[] = {                                                        
"                                                                           \n\ 
 Startup options:                                                           \n\ 
 ---------------                                                            \n\ 
                                                                            \n\ 
 Used on server only:                                                       \n\ 
 -------------------                                                        \n\ 
   -d<#>   : debugging , # = level of debugging                             \n\ 
                           0: no tracing  (default)                         \n\ 
                           1: simple monitoring                             \n\ 
                           2: simple trace                                  \n\ 
                           3: more trace.                                   \n\ 
                           >=4: ioctl/datagram contents                     \n\ 
   -montcpip  : indicates that the server is to establish a                 \n\ 
                connection to the TCPIP address space for monitoring.       \n\ 
                                                                            \n\ 
                                                                            \n\ 
 Used on client only:                                                       \n\ 
 -------------------                                                        \n\ 
   -d<#>   : debugging , # = level of debugging                             \n\ 
                           0: no tracing (default)                          \n\ 
                           1: simple monitoring.                            \n\ 
                           2: simple trace.                                 \n\ 
                           3: more trace.                                   \n\ 
                           4-9: ioctl/datagram contents                     \n\ 
                           #>=10: plot information                          \n\ 
                           f: debug fork.                                   \n\ 
                           p: debug print.                                  \n\ 
                           t: debug timing.                                 \n\ 
                           x: debug X.                                      \n\ 
   -h<your_MVS_host> : specifies the host you wish to monitor.              \n\ 
                 '<your_MVS_host>' can be either the symbolic name or       \n\ 
                 dotted decimal address of your host to be monitored.       \n\ 
   -xmonexcp  : selects a small window containing (possibly)                \n\ 
                exceptional events to monitor.                              \n\ 
   -xmonload  : selects a larger window containing more variables           \n\ 
                from TCPIP to monitor.                                      \n\ 
                                                                            \n\ 
                                                                            \n\ 
 Used on both client and server:                                            \n\ 
 ------------------------------                                             \n\ 
                                                                            \n\ 
   -po<#>  : specifies port to use.  Both server and client should          \n\ 
             be using the same port number.  The default is 5001.           \n\ 
                                                                          \n"}; 
char help_string2b[] = {                                                        
" Resources specified in your .Xdefaults file on client:                    \n\ 
 -----------------------------------------------------                      \n\ 
!cbsample.sampleInterval:                      1                            \n\ 
!  This parameter determines how often the monitor will request a sample    \n\ 
!  from the server.  The default is once per second.                        \n\ 
                                                                            \n\ 
!cbsample.timeoutForSelect:                    1                            \n\ 
!  This parameter determines how long the monitor will wait for the server  \n\ 
!  to respond to a request for the next sample data before it times out     \n\ 
!  and displays a vertical black line on the plots for that cycle.  The     \n\ 
!  default is 1 second.                                                     \n\ 
                                                                            \n\ 
!cbsample.colorWhenServerTimesout:            Black                         \n\ 
!  This parameter specifies the color of the vertical bar shown on the plots\n\ 
!  to represent that the request made to the server timed out for that      \n\ 
!  cycle.  The default is black.  You might prefer red, say.                \n\ 
                                                                            \n\ 
!cbsample.addVariationToSample:               5                             \n\ 
!  This parameter can be used to add more or less variation to the time at  \n\ 
!  which the request for sample data is made to the server.  This is to     \n\ 
!  avoid \"beating against\" other activity occurring either on the         \n\ 
!  workstation, network, or host.  The default is 5 ms.  So, by default, the\n\ 
!  client requests a sample from the server each 1 second +/- 5 milliseconds\n\ 
!  (using a uniform distribution).  Note that the requests are synchronous  \n\ 
!  with the 1 second tick mark of the clock on the client (plus or minus    \n\ 
!  this variation).                                                         \n\ 
                                                                            \n\ 
!cbsample.numTriesBeforeStartingToWhine:      1                             \n\ 
!cbsample.maxTriesBeforeGivingUp:            10                             \n\ 
!  These parameters determine how many cycles we allow to elapse without    \n\ 
!  receiving a response from TCPIP before we start to print messages, and   \n\ 
!  how many times we will continue to try to contact TCPIP before giving up.\n\ 
!  The defaults are 1 and 10.                                               \n\ 
                                                                            \n\ 
!cbsample.showMillisecondsOnMonitor:          False                         \n\ 
!  This parameter pertains to the Time of Day displayed below the buttons.  \n\ 
!  The default is to only display seconds on the monitor TOD.               \n\ 
                                                                            \n\ 
!cbsample.title:                              title goes here               \n\ 
!  The title defaults to the hostname on the '-h' parameter.  The title is  \n\ 
!  displayed on the top of the monitor window.                              \n\ 
                                                                          \n"}; 
                                                                                
/**********************************************************************/        
                                                                                
char help_string3a[] = {                                                        
"                                                                           \n\ 
 About the buttons:                                                         \n\ 
 -----------------                                                          \n\ 
                                                                            \n\ 
  Start     - to start the client monitor.                                  \n\ 
  Clear     - to clear the display.                                         \n\ 
  Quit      - to stop the client.                                           \n\ 
                                                                            \n\ 
  Trace     - starts and stops tracing the TCPIP data.  The trace is sent   \n\ 
              to stdout.  If you want to capture this, you can redirect     \n\ 
              stdout.  For example:                                         \n\ 
                                                                            \n\ 
                        cbsample -xmonexcp -hyktmvs > trace.file            \n\ 
                                                                            \n\ 
  Threshold - starts and stops threshold checking.  Threshold rules are     \n\ 
              defined in the file called, cbsample.threshs, in the          \n\ 
              subdirectory where you start cbsample.  The threshold button  \n\ 
              resets (returns to it\'s normal blue color) when all rules    \n\ 
              have completed firing.  The threshold rules are read in at the\n\ 
              time the button is pressed.  See the cbsample.threshs file for\n\ 
              examples. Syntax of the threshold rules follows:              \n\ 
      ----------------------------------------------------------------------\n\ 
      if <signal-name> {\">\"|\"<\"|\"=\"|\">=\"|\"<=\"} <threshold-value>  \n\ 
                                                                            \n\ 
         [for <num-cycles>]                                                 \n\ 
                                                                            \n\ 
              { StartTrace                 }                                \n\ 
              { StopTrace                  }                                \n\ 
         then { SnapCommand[1|2|3]         }  [just <num-times>]            \n\ 
              { PrintCommand[1|2|3]        }                                \n\ 
              { system(\"<shell-commands>\") }                              \n\ 
              { NoAction                   }                                \n\ 
      ----------------------------------------------------------------------\n\ 
      <signal-name>      is as listed on the display or found in the        \n\ 
                         \"About the signals\" help frame.                  \n\ 
      Next comes the threshold condition.  For example, \">\" signifies that\n\ 
                         the signal has to be greater than the              \n\ 
                         <threshold-value> for the rule to fire.            \n\ 
      <threshold-value>  is integer, except for TurnaroundTime which is     \n\ 
                         float.                                             \n\ 
      for <num-cycles>   means the condition has to be true for that many   \n\ 
                         cycles in a row for the rule to fire. The parameter\n\ 
                         is optional.  The default is 1 cycle.              \n\ 
      StartTrace         starts the trace to stdout.                        \n\ 
      StopTrace          stops the trace.  (This rule only fires if trace is\n\ 
                         running when the condition is satisfied.)        \n"}; 
char help_string3b[] = {                                                        
"      SnapCommand1       corresponds to the action defined by              \n\ 
                         \"cbsample*Snapshot.snapCommand1\" in your         \n\ 
                         .Xdefaults file when the monitor was started.      \n\ 
                         Similarly for snapCommand2 and and snapCommand3.   \n\ 
                         Note that the spelling of \"snapCommand\" is case- \n\ 
                         sensitive in your .Xdefaults file.                 \n\ 
      PrintCommand1      corresponds to the action defined by               \n\ 
                         \"cbsample*Print.printcommand1\" in your .Xdefaults\n\ 
                         when the monitor was started.  Similarly for       \n\ 
                         PrintCommand2 and and PrintCommand3.  Note that the\n\ 
                         spelling of \"printCommand\" is case-sensitive in  \n\ 
                         your .Xdefaults file.                              \n\ 
      <shell-commands>   can be any valid shell commands.  You can invoke   \n\ 
                         a shell script to do additional work.  A sample    \n\ 
                         script called, DontPanic, is provided.             \n\ 
      NoAction           means on no action is performed.  But a message,   \n\ 
                         indicating that the rule has fired, will show up in\n\ 
                         the messages written to stdout.                    \n\ 
      just <num-times>   means the rule will fire that many times, after    \n\ 
                         which it is disabled.  To reenable it, press the   \n\ 
                         Threshold button again.  The default is to fire the\n\ 
                         rule once.                                         \n\ 
      ----------------------------------------------------------------------\n\ 
      Example:                                                              \n\ 
          \"When the TCPIP turnaround time (to the monitor requests) exceeds\n\ 
          1/2 second for 4 cycles in a row, snapshot the window.  Do this   \n\ 
          up to 3 times.\"  The rule for this is:                           \n\ 
                                                                            \n\ 
            if TurnaroundTime > 0.500 for 4 then snapcommand1 just 3        \n\ 
                                                                            \n\ 
          Note that when the server doesn't respond within 1 second (the    \n\ 
          default), the client times out and reports the TurnaroundTime as  \n\ 
          (roughly) one second in the plot of TurnaroundTime on the display.\n\ 
          The plots would show a vertical black line for that sample        \n\ 
          interval. If thresholding was enabled, the above threshold rule   \n\ 
          would also fire.                                                  \n\ 
                                                                            \n\ 
      ----------------------------------------------------------------------\n\ 
                                                                            \n\ 
  Help      - to display (this) help.                                       \n\ 
                                                                          \n"}; 
char help_string3c[] = {                                                        
"  Snapshot  - causes the monitor to be captured and output to a file called\n\ 
              \"cbsample.snapshot.xwd\".  This file is in standard \"xwd\"  \n\ 
              format.  Then, one of the actions defined by:                 \n\ 
                                                                            \n\ 
                     cbsample*Snapshot.snapCommand1                         \n\ 
                     cbsample*Snapshot.snapCommand2                         \n\ 
                     cbsample*Snapshot.snapCommand3                         \n\ 
                                                                            \n\ 
              in your .Xdefaults file is performed.                         \n\ 
              If you pressed the left mouse button (Button1), snapCommand1  \n\ 
              will be invoked.  The middle and right buttons invoke         \n\ 
              snapCommand2 and snapCommand3, respectively.  Note that the   \n\ 
              spelling of \"snapCommand\" is case-sensitive in your         \n\ 
              .Xdefaults file.                                              \n\ 
                                                                            \n\ 
                     cbsample*Snapshot.convertOutputToMonochrome1: true     \n\ 
                                                                            \n\ 
              causes a monochrome version to be created for snapCommand1.   \n\ 
              Similarly for 2 and 3.  Normally, on a color display, you     \n\ 
              would want to create a color snapshot.  If you need to print  \n\ 
              the image later on a black & white printer, you may want to   \n\ 
              snapshot it in monochrome.  The Xdefaults supplied in the     \n\ 
              cbsample distribution tar file has Button1 set for color, and \n\ 
              Button2 set for monochrome.                                   \n\ 
                                                                            \n\ 
  Print     - causes the monitor to be captured and output to a file called,\n\ 
              \"cbsample.print.xwd\".  This file is in standard \"xwd\"     \n\ 
              format.  Then one of the actions defined by:                  \n\ 
                                                                            \n\ 
                     cbsample*Print.printCommand1                           \n\ 
                     cbsample*Print.printCommand2                           \n\ 
                     cbsample*Print.printCommand3                           \n\ 
                                                                            \n\ 
              in your .Xdefaults file is performed.                         \n\ 
              If you pressed the left mouse button (Button1), printCommand1 \n\ 
              will be invoked.  The middle and right buttons invoke         \n\ 
              printCommand2 and printCommand3, respectively.  Note that the \n\ 
              spelling of \"printCommand\" is case-sensitive in your        \n\ 
              .Xdefaults file.                                              \n\ 
                                                                            \n\ 
                     cbsample*Print.convertOutputToMonochrome1: true        \n\ 
                                                                            \n\ 
              causes a monochrome version to be created for printCommand1.  \n\ 
              Similarly for 2 and 3.  If the xpr command on your workstation\n\ 
              supports gray-scale conversion, you might want to select false\n\ 
              for this option (generating a color xwd-format file), and use \n\ 
              the '-gray' option on xpr.  The sample Xdefaults file supplied\n\ 
              in the cbsample distribution tar file has Button2 setup this  \n\ 
              way.                                                          \n\ 
                                                                          \n"}; 
                                                                                
char help_string3d[] = {                                                        
"  Installation:                                                            \n\ 
                                                                            \n\ 
     Please review the following before using these options:                \n\ 
                                                                            \n\ 
        Snapshot option:  This opt. assumes you have access to the \"xwud\" \n\ 
                          command.  This may be found in X11 samples code   \n\ 
                          (in /usr/lpp/X11/Xamples/clients/xwud on AIX) or  \n\ 
                          it may already be accessible on your system.  To  \n\ 
                          see if you have it, issue \"xwd | xwud\".  When it\n\ 
                          prompts you (with a crosshair cursor), move the   \n\ 
                          cursor to a small window, and click one of the    \n\ 
                          mouse buttons.  A copy of the window should be    \n\ 
                          displayed.  If the system does not find \"xwud\", \n\ 
                          you might try \"find / -print | grep xwud\" to    \n\ 
                          see if the command is located on your system      \n\ 
                          but possibly not accessible.  If you find it,     \n\ 
                          make sure there is an executable, and add it's    \n\ 
                          subdirectory to your PATH environmental variable. \n\ 
                                                                            \n\ 
        Print option:     This opt. assumes you have access to a Postscript \n\ 
                          printer.  Change the \"-P\" option on the \"lpr\" \n\ 
                          command on the \"cbsample*Print.printCommand1\"   \n\ 
                          and \"cbsample*Print.printCommand2\" statements   \n\ 
                          in your .Xdefaults file to the name of your       \n\ 
                          Postscript printer queue.                         \n\ 
                                                                            \n\ 
        Debugging         For debugging purposes, there is a binary-to-hex  \n\ 
        Snapshot and      print utility provided in the tar file.  It is    \n\ 
        Print options:    called b2h.c.  If you need to use this utility,   \n\ 
                          issue the following to create the executable:     \n\ 
                                                                            \n\ 
                                         make b2h                           \n\ 
                                                                            \n\ 
                          The utility is used when mouse Button3 (the right \n\ 
                          button) is pressed over the Snapshot button or    \n\ 
                          Print button.                                     \n\ 
                                                                            \n\ 
        Threshold option: One of the sample threshold rules in              \n\ 
                          cbsample.threshs calls a shell script, called     \n\ 
                          DontPanic, that assumes you have access to rexec  \n\ 
                          on the host.  See the instructions in the         \n\ 
                          DontPanic file.                                   \n\ 
                                                                          \n"}; 
                                                                                
                                                                                
/**********************************************************************/        
char help_string4[] = {                                                         
"                                                                           \n\ 
 About the plots:                                                           \n\ 
 ---------------                                                            \n\ 
                                                                            \n\ 
 The monitor shows timeseries plots of the variables.  The monitor is       \n\ 
 updated approximately every second, and approximately 200 seconds of       \n\ 
 previous activity are shown.  Below each plot are the names of the         \n\ 
 variables in colors corresponding to the line color in the plot.  The      \n\ 
 number directly to the right of a variable name is its value from the      \n\ 
 previous interval. The second number is the average for the variable.      \n\ 
                                                                            \n\ 
 If the server times out (ie. doesn't respond to the client's request       \n\ 
 within 1 second), a black bar is displayed on the plot for that cycle.     \n\ 
 You can change this color using the \"cbsample.colorWhenServerTimesout\"   \n\ 
 resource in your .Xdefaults file.  You might prefer red, say.              \n\ 
                                                                            \n\ 
 You can reset a plot by clicking the left mouse button when the cursor     \n\ 
 is over the plot.  You can reset all plots by pressing the Clear button.   \n\ 
                                                                          \n"}; 
                                                                                
                                                                                
/**********************************************************************/        
char help_string5a[] = {                                                        
"                                                                           \n\ 
 About the signals:                                                         \n\ 
 -----------------                                                          \n\ 
                                                                            \n\ 
 Following is a brief description of each of the signals.                   \n\ 
 Refer to Appendix C of the TCP/IP User's Guide for more information on the \n\ 
 signals (except for signals marked \"*\").                                 \n\ 
                                                                            \n\ 
 arpInRequests   Number of ARP requests received. (*)                       \n\ 
 arpInReplies    Number of ARP replies received.  (*)                       \n\ 
 arpOutRequests  Number of ARP requests sent.     (*)                       \n\ 
 arpOutReplies   Number of ARP replies sent.      (*)                       \n\ 
                                                                            \n\ 
 icmpInMsgs      Number of ICMP messages received.                          \n\ 
 icmpOutMsgs     Number of ICMP messages sent.                              \n\ 
                                                                            \n\ 
 ioReads         Number of Read I/O operations performed.       (*)         \n\ 
 ioWrites        Number of Write I/O operations performed.      (*)         \n\ 
 ioInOctets      Number of kilobytes received from LAN I/O devices. (*)     \n\ 
 ioOutOctets     Number of kilobytes sent to LAN I/O devices.       (*)     \n\ 
                                                                            \n\ 
 ipForwDatagrams Number of IP datagrams forwarded by this host.             \n\ 
 ipFragCreates   Number of IP datagram fragments generated.                 \n\ 
 ipFragFails     Number of IP datagram that should have been fragmented     \n\ 
                 but were not because their \"Do not Fragment\" flag was on.\n\ 
 ipFragOKs       Number of IP datagrams that have fragmented without        \n\ 
                 problems.                                                  \n\ 
 ipInAddrErrors  Number of input datagrams discarded because the IP address \n\ 
                 in their destination field was not valid for this host.    \n\ 
 ipInHdrErrors   Number of input datagrams discarded because of errors in   \n\ 
                 their IP headers (ex. checksum, version, format, TTL,      \n\ 
                 options)                                                   \n\ 
 ipInReceives    Number of input datagrams received.                        \n\ 
 ipOutRequests   Number of output datagrams sent.                           \n\ 
 ipReasmFails    Number of failures detected by the IP reassembly algorithm.\n\ 
 ipReasmOKs      Number of IP datagrams reassembled without problems.       \n\ 
 ipReasmReqds    Number of IP fragments received and need to be reassembled \n\ 
                 by this host.                                              \n\ 
                                                                          \n"}; 
                                                                                
char help_string5b[] = {                                                        
"tcpInSegs       Number of TCP segments received.                           \n\ 
 tcpOutSegs      Number of TCP segments sent.                               \n\ 
 tcpRetransSegs  Number of TCP segments retransmitted.                      \n\ 
 tcpConnections  Current number of established TCP connections.             \n\ 
                                                                            \n\ 
 udpInDatagrams  Number of UDP datagrams received.                          \n\ 
 udpOutDatagrams Number of UDP datagrams sent.                              \n\ 
                                                                            \n\ 
                                                                          \n"}; 
char help_string5c[] = {                                                        
"csaTotAllocated Total Common Storage Area Allocated.              (*)      \n\ 
 csaTotInUse     Total Common Storage Area in use.                 (*)      \n\ 
                                                                            \n\ 
 TotCPUtime      Cumulative CPU time used by TCP/IP address space. (*)      \n\ 
                                                                            \n\ 
 TurnaroundTime  The turnaround time is measured from (just before) the     \n\ 
                 point at which we issued the request to TCPIP for data     \n\ 
                 to the point (just after) we received the response. (*)    \n\ 
                                                                          \n"}; 
#endif                                                                          
